// Need to cache all DOM access to speed things up.
no_nsfw_page = {
	warning : '',

	waiting : {},

	rating : [],

	mouseover : function (e) {
		// either href, or target == img, and parent.href ?

		try {
			var tag = e.target.tagName;

			// either anchor, or elem with parent an anchor.
			if (tag == 'A')
				var href = e.target.getAttribute ('href');
			else
				var href = e.target.parentNode.getAttribute ('href');

		} catch (e) {
			return true;
		}

		if (typeof href == 'undefined')
			return true;

		if (href.substring (0, 7) != 'http://')
			return true;
	
		var link_domain = this.domain (href);
		var domain = this.domain (window.location.href);

		// no action if internal link
		if (link_domain == domain)
			return true;
	
		// start ... animation, and wait for response.
		this.warning = 'waiting';
		this.show ('no-nsfw-waiting');
		this.position ('no-nsfw-waiting');

		if (typeof this.rating [href] != 'undefined') {
			this.response ({"url":href, "rating":no_nsfw_page.rating [href]});
			return true;
		}

		// check if cookie contains value.
		this.js ('http://nonsfw.com/ajax/query?url='+this.esc (href));

		var animate = function () {
			var dot = document.getElementById ('no-nsfw-waiting').innerHTML;
			document.getElementById ('no-nsfw-waiting').innerHTML = (dot.length < 58) ? dot + '. ' : '<img src="chrome://no-nsfw/content/magnifier.png">';
			no_nsfw_page.waiting = setTimeout (animate, 400);
		};

		this.waiting = setTimeout (animate, 400);

		return true;
	},

	href : function (e) {

	},

	// center all warnings.
	position : function (id) {
		var width = document.getElementById (id).offsetWidth;
		var scrwidth = window.innerWidth;

		if (window.scrollMaxY == 0)
			document.getElementById (id).style.left = (scrwidth - width) + 'px';
		else
			document.getElementById (id).style.left = (scrwidth - width - 16) + 'px';
	},

	// as few DOM calls as possible.
	// would cookie calls be as costly ?
	// using the variable cache would be better.
	show : function (id) {
		document.getElementById (id).style.display = 'block';
	},

	mouseout : function (e) {
		if (this.warning) {
			document.getElementById ('no-nsfw-'+this.warning).style.display = 'none';
			this.warning = '';
		}

		clearTimeout (this.waiting);

		return true;
	},

	// json data ?
	// could store in week-ttl cookies.
	response : function (data) {
		// json type data.
		// expect - {"link" : "rating", ...}
		// nothing for unrated, only sfw and nsfw type ratings returned.
		// now only a single value returned

		/*this.ratings = data;

		// set a week long cookie, but use variable data for quicker access
		for (url in data) {
			this.cookie (url, data [url]);
		}*/

		// check if current url, is the url returned, else just archive as cookie and move on.
		// also if warning is active ? - both are almost the same actually

		// this could crash no-nsfw if not focused on that tab !!
		// console.dir (data);

		if (this.warning) {
			document.getElementById ('no-nsfw-'+this.warning).style.display = 'none';
			this.warning = '';

			// should store this cross-domain !! or waste http requests.
			this.rating [data.url] = data.rating;

			if (data.rating == 'unsafe') {
				this.warning = 'unsafe';
				this.show ('no-nsfw-unsafe');
				this.position ('no-nsfw-unsafe');
			}

			else if (data.rating == 'safe') {
				this.warning = 'safe';
				this.show ('no-nsfw-safe');
				this.position ('no-nsfw-safe');
			}

			else if (data.rating == 'unrated') {
				this.warning = 'unrated';
				this.show ('no-nsfw-unrated');
				this.position ('no-nsfw-unrated');
			}
		}


	},

	esc : function (url) {
		var escurl;

		try {
			escurl = encodeURIComponent (url);
		} catch(e) {
			escurl = escape (url);
		}

		return escurl;
	},

	// unesc url - mostly for cookie data.
	unesc : function (data) {
		var url;

		try {
			url = encodeURIComponent (data);
		} catch(e) {
			url = escape (data);
		}

		return url;
	},

	cookie : function (name, value) {
		if (typeof value != 'undefined') {
			var ttl = 7;

			var date = new Date ();
			date.setTime (date.getTime () + (ttl * 24 * 60 * 60 * 1000));
			var expires = '; expires=' + date.toGMTString ();

			var path = '; path=/';
			var domain = '; domain=' + this.domain (window.location.href).substring (7);
			document.cookie = [name, '=', encodeURIComponent (value), expires, path, domain].join ('');

		} else {
			var cookieValue = null;

			if (document.cookie && document.cookie != '') {
				var cookies = document.cookie.split (';');

				for (var i = 0; i < cookies.length; i++) {
					var cookie = cookies [i].replace (/^\s+|\s+$/g, "");

					if (cookie.substring (0, name.length + 1) == (name + '=')) {
						cookieValue = decodeURIComponent (cookie.substring (name.length + 1));
						break;
					}
				}
			}

			return cookieValue;
		}
	},

	domain : function (url) {
		var parts = url.match (/^http:\/\/[^\/]*/)
		return parts [0];
	},

	js : function (url) {
		var elem = document.createElement ('script');
		elem.setAttribute ('src', url);
		elem.setAttribute ('type','text/javascript');
		document.getElementsByTagName ('head') [0].appendChild (elem);
	},

	warning : function (type, label) {
		var elem = document.createElement ('div');
		elem.id = 'no-nsfw-'+type;
		elem.className = 'no-nsfw-warning';
		elem.innerHTML = '<img src="chrome://no-nsfw/content/magnifier.png">' + label;

		document.body.appendChild (elem);
	},

	// could store as string 'nsfw', 'sfw', 'unrated'
	rating : function (url, rating) {
		try {
			if (typeof rating == 'undefined')
				this.ratings [url] = rating;
			else
				return this.ratings [url];
		} catch (e) {
			return false;
		}
	},

	init : function () {
		// doesn't work for a>img, need to hunt them, and attach to the img instead ?
		document.addEventListener ("mouseover", function (e) {return no_nsfw_page.mouseover (e);}, true);
		document.addEventListener ("mouseout", function (e) {return no_nsfw_page.mouseout (e);}, true);

		this.warning ('unrated', 'Unrated ');
		this.warning ('unsafe', 'NSFW ');
		this.warning ('safe', 'SFW ');
		this.warning ('waiting', '');

		// timed, to convert to thank you .. !
		this.warning ('vote-nsfw', 'Flagged as NSFW.');
		this.warning ('vote-sfw', 'Marked as SFW.');
	}
};

// single point entry
no_nsfw_page.init ();
